      PROGRAM TPDPBSV
*
*       ணࠬ PDPBSV
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            DLEN_, JA, IB, N, NB, RSRC, CSRC,
     $                   MXLLDA, MXLLDB, NRHS, NBRHS, NOUT,
     $                   MXLOCR, MXLOCC, MXRHSC, BW
      PARAMETER          ( DLEN_ = 7, JA = 1, IB = 1,
     $                   N = 9, NB = 3, RSRC = 0,
     $                   CSRC = 0, MXLLDA = 2, MXLLDB = 3, NRHS = 1,
     $                   NBRHS = 1, NOUT = 6, MXLOCR = 3, MXLOCC = 3,
     $                   MXRHSC = 1, BW = 1, LWORK = 6 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'L' )
*
*  ६ ..
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
*
*  ᨢ ..
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ )
      DOUBLE PRECISION   A( MXLLDA, MXLOCC ), B( MXLLDB, MXRHSC ),
     $                   WORK( LWORK )
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   MATINIT, PDPBSV, SL_INIT
*
*   DATA ..
      DATA               NPROW / 1 / , NPCOL / 3 /
*
* 믮  ..
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      DESCA(1) = 501
      DESCA(2) = ICTXT
      DESCA(3) = N
      DESCA(4) = NB
      DESCA(5) = CSRC
      DESCA(6) = 2
      DESCA(7) = 0
*
      DESCB(1) = 502
      DESCB(2) = ICTXT
      DESCB(3) = N
      DESCB(4) = NB
      DESCB(5) = RSRC
      DESCB(6) = 3
      DESCB(7) = 0
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )N, N, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO, BW
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
      END IF
 9985 FORMAT( / 7I5 /)
 9988 FORMAT( / ' UPLO = ', A, '   BW =', I3 /)
*
      CALL BLACS_BARRIER( ICTXT, 'R' )
*
*   A  B  ।  ⪥ ᮢ
*
      CALL MATINIT( A, DESCA, B, DESCB )
*
      CALL BLACS_BARRIER( ICTXT, 'R' )
*
*  室  ⥩  A  B    ᮢ
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9990 )MYROW, MYCOL, A
      END IF
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.1 ) THEN
         WRITE( NOUT, FMT = 9990 )MYROW, MYCOL, A
      END IF
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.2 ) THEN
         WRITE( NOUT, FMT = 9990 )MYROW, MYCOL, A
      END IF
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9989 )MYROW, MYCOL, B
      END IF
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.1 ) THEN
         WRITE( NOUT, FMT = 9989 )MYROW, MYCOL, B
      END IF
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.2 ) THEN
         WRITE( NOUT, FMT = 9989 )MYROW, MYCOL, B
      END IF
 9990 FORMAT( '(',I3, I3,')', '  A' / 1P, (3E16.8) )
 9989 FORMAT( '(',I3, I3,')', '  B' / 1P, 3E19.8 /)
*
      CALL BLACS_BARRIER( ICTXT, 'R' )
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL  PDPBSV ( UPLO, N, BW, NRHS, A, JA, DESCA,
     $               B, IB, DESCB, WORK, LWORK, INFO)
*
      CALL BLACS_BARRIER( ICTXT, 'R' )
*
*   ⥩ १⮢ X    ᮢ
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9986 )MYROW, MYCOL, B
      END IF
*
 9986 FORMAT( / '(', I3, I3,')', '  X ( B)' / 1P, 3E16.8 )
*
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.1 ) THEN
         WRITE( NOUT, FMT = 9986 )MYROW, MYCOL, B
      END IF
      CALL BLACS_BARRIER( ICTXT, 'R' )
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.2 ) THEN
         WRITE( NOUT, FMT = 9986 )MYROW, MYCOL, B
      END IF
*
* ᢮  ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '   ணࠬ PDPBSV' )
 9998 FORMAT( / ' 襭 A X = B ,' //
     $       '  A - ᨬ筠 筠  ',
     $       I2, '  ', I2, ',' / '      ࠧ',
     $       '    ⮫栬 ', I2,' ⮫  ' /)
 9997 FORMAT( '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
      STOP
      END
*
      SUBROUTINE MATINIT( A, DESCA, B, DESCB )
*
* MATINIT   ।  A  B
*          ⪥ ᮢ 1 x 3
*
* ࠬ - ᨢ ..
      INTEGER            DESCA( * ), DESCB( * )
      DOUBLE PRECISION   A( * ), B( * )
*
* Parameters ..
      INTEGER            CTXT_
      PARAMETER          ( CTXT_ = 2 )
*
*  ६ ..
      INTEGER            ICTXT, MYCOL, MYROW, NPCOL, NPROW
      DOUBLE PRECISION   MO, T, Z
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_GRIDINFO
*
* 믮  ..
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
      T = 2.0D0
      Z = 0.0D0
      MO = -1.0D0
*
*    A  B   (0, 0)
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         A( 1 ) = T
         A( 2 ) = MO
         A( 3 ) = T
         A( 4 ) = MO
         A( 5 ) = T
         A( 6 ) = MO
*
         B( 1 ) = Z
         B( 2 ) = Z
         B( 3 ) = Z
*
*    A  B   (0, 1)
*
      ELSE IF( MYROW.EQ.0 .AND. MYCOL.EQ.1 ) THEN
         A( 1 ) = T
         A( 2 ) = MO
         A( 3 ) = T
         A( 4 ) = MO
         A( 5 ) = T
         A( 6 ) = MO
*
         B( 1 ) = Z
         B( 2 ) = Z
         B( 3 ) = Z
*
*    A  B   (0, 2)
*
      ELSE IF( MYROW.EQ.0 .AND. MYCOL.EQ.2 ) THEN
         A( 1 ) = T
         A( 2 ) = MO
         A( 3 ) = T
         A( 4 ) = MO
         A( 5 ) = 1.0D0
         A( 6 ) = Z
*
         B( 1 ) = Z
         B( 2 ) = Z
         B( 3 ) = 1.0D0
      END IF
      RETURN
      END
